var angular = require('angular');
require('../modules');

var module = angular.module('commons.services.configService');

  module.factory('configService', function($http, $q) {
  var configService = {
    getConfig: function() {
        if (ionic.Platform.isIOS() && window.SinoNetwork && window.SinoNetwork.getConfigs) {
            var deferred = $q.defer();
            window.SinoNetwork.getConfigs(function(configs) {
                deferred.resolve(configs);
            }, function(error) {
                deferred.reject(error);
            });
            return deferred.promise;
        } else {
            return $http.get('config.json?views').then(function(response) {
                var config = response.data;
                return config;
            });
        }
    },

    get: function(serverId) {
      return this.getConfig().then(function(config) {
        var servers = config.filter(function(server) {
          return server.id === serverId
        });
        if (servers && servers.length > 0) {
          return servers[0];
        }
      });
    },

    /** 保存server和vpnServerUrl到手机端插件,并重新获取连接 */
    saveAppConfig: function(data) {
      var deferred = $q.defer();
      if (window.SinoNetwork) {
        window.SinoNetwork.configsave(data, function() {
          deferred.resolve(true);
        }, $q.reject);
      } else {
        deferred.resolve(true);
      }
      return deferred.promise;
    },
  };

  return configService;
});
