var angular = require('angular'),
  _ = require('jsUtil');
require('../modules');
require('../../flow/services/WorkflowTransfer');
require('./DefaultWorkflowRequest');
require('../../linker/services/LinkerService');
require('../../flow/services/NotionService');

var module = angular.module('flowmodulebutton.services');

module.factory('DefaultWorkflowService', function(WorkflowTransfer, DefaultWorkflowRequest, LinkerService,
  NotionService) {
  return {
    finish: finish,
    send: send
  };

  function finish(requestParam) {
    setNotionParam(requestParam);
    var workflowRequest = DefaultWorkflowRequest.generateFinishWorkflowRequest(requestParam);
    requestParam.onStateChange('generateWorkflowRequest');
    return WorkflowTransfer.finish(workflowRequest);
  }

  function send(requestParam) {
    setNotionParam(requestParam);
    var workflowRequest = DefaultWorkflowRequest.generateWorkflowRequest(requestParam, requestParam.transferflag,
      requestParam.contents);
    requestParam.onStateChange('generateWorkflowRequest');
    return WorkflowTransfer.send(workflowRequest);
  }

  function setNotionParam(requestParam) {
    requestParam.contents = requestParam.tempNotions.map(function(tempNotion) {
      if (tempNotion.requireFn()) {
        if (_.isEmpty(tempNotion.content) && (!tempNotion.tempSign)) {
          requestParam.onStateChange('needWriteNotion');
          throw new Error('1');//需要填写意见
        }
      }
      return tempNotion.content;
    });
  }
});
