'use strict';

var angular = require('angular'),
  _ = require('jsUtil');
require('../modules');

var module = angular.module('info.filters');

 module.filter('moduleshowfilter', function(LinkerService, CacheService, AppConfig) {

  function showModule(module, currentUserId) {
    var currentAppConfig = CacheService.get('currentAppConfig');

    var _one = false, _province = false;
    if(module.showToSomeOne) {
      _.each(module.showToSomeOne, function(one) {
        if(one === currentUserId) {
          _one = true;
        }
      });
    }
    if(AppConfig.getCustomResult('infoEnable', false)) {
      _province = true;
    }
    return _one || _province;
  }
  return function(modules) {
    var _items = [];
    var currentUserId = LinkerService.currentUserId;
    if(!modules || !currentUserId) { return modules;}
    for(var i = 0, len = modules.length; i < len; i++) {
      var module = modules[i];
      if(module && (module.showToSomeOne || module.showToSomeProvince)) {
        if(showModule(module, currentUserId)) {
          _items.push(module);
        }
      } else {
        _items.push(module);
      }
    }

    return _items;
  }
});
